/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TGENECONCEPTDESC")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tgeneconceptdesc.findAll", query = "SELECT t FROM Tgeneconceptdesc t"),
    @NamedQuery(name = "Tgeneconceptdesc.findByConceptmodule", query = "SELECT t FROM Tgeneconceptdesc t WHERE t.tgeneconceptdescPK.conceptmodule = :conceptmodule"),
    @NamedQuery(name = "Tgeneconceptdesc.findByConceptcode", query = "SELECT t FROM Tgeneconceptdesc t WHERE t.tgeneconceptdescPK.conceptcode = :conceptcode"),
    @NamedQuery(name = "Tgeneconceptdesc.findByLanguagecode", query = "SELECT t FROM Tgeneconceptdesc t WHERE t.tgeneconceptdescPK.languagecode = :languagecode"),
    @NamedQuery(name = "Tgeneconceptdesc.findByRecordversion", query = "SELECT t FROM Tgeneconceptdesc t WHERE t.recordversion = :recordversion"),
    @NamedQuery(name = "Tgeneconceptdesc.findByDescription", query = "SELECT t FROM Tgeneconceptdesc t WHERE t.description = :description")})
public class Tgeneconceptdesc implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TgeneconceptdescPK tgeneconceptdescPK;
    @Column(name = "RECORDVERSION")
    private BigInteger recordversion;
    @Column(name = "DESCRIPTION")
    private String description;
    @JoinColumns({
        @JoinColumn(name = "CONCEPTMODULE", referencedColumnName = "CONCEPTMODULE", insertable = false, updatable = false),
        @JoinColumn(name = "CONCEPTCODE", referencedColumnName = "CONCEPTCODE", insertable = false, updatable = false)})
    @ManyToOne(optional = false)
    private Tgeneconcept tgeneconcept;
    @JoinColumn(name = "LANGUAGECODE", referencedColumnName = "LANGUAGECODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenelanguage tgenelanguage;

    public Tgeneconceptdesc() {
    }

    public Tgeneconceptdesc(TgeneconceptdescPK tgeneconceptdescPK) {
        this.tgeneconceptdescPK = tgeneconceptdescPK;
    }

    public Tgeneconceptdesc(String conceptmodule, short conceptcode, String languagecode) {
        this.tgeneconceptdescPK = new TgeneconceptdescPK(conceptmodule, conceptcode, languagecode);
    }

    public TgeneconceptdescPK getTgeneconceptdescPK() {
        return tgeneconceptdescPK;
    }

    public void setTgeneconceptdescPK(TgeneconceptdescPK tgeneconceptdescPK) {
        this.tgeneconceptdescPK = tgeneconceptdescPK;
    }

    public BigInteger getRecordversion() {
        return recordversion;
    }

    public void setRecordversion(BigInteger recordversion) {
        this.recordversion = recordversion;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Tgeneconcept getTgeneconcept() {
        return tgeneconcept;
    }

    public void setTgeneconcept(Tgeneconcept tgeneconcept) {
        this.tgeneconcept = tgeneconcept;
    }

    public Tgenelanguage getTgenelanguage() {
        return tgenelanguage;
    }

    public void setTgenelanguage(Tgenelanguage tgenelanguage) {
        this.tgenelanguage = tgenelanguage;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tgeneconceptdescPK != null ? tgeneconceptdescPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tgeneconceptdesc)) {
            return false;
        }
        Tgeneconceptdesc other = (Tgeneconceptdesc) object;
        if ((this.tgeneconceptdescPK == null && other.tgeneconceptdescPK != null) || (this.tgeneconceptdescPK != null && !this.tgeneconceptdescPK.equals(other.tgeneconceptdescPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tgeneconceptdesc[ tgeneconceptdescPK=" + tgeneconceptdescPK + " ]";
    }
    
}
